# -*- coding: utf-8 -*-

#changer de dossier
import os
os.chdir("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/feature_selection/partial_dep_plot")

#charger les données
import pandas
autos = pandas.read_csv("autos_pdp.txt",sep="\t",header=0)
print(autos.info())

#gradient boosting
from sklearn.ensemble import GradientBoostingClassifier
m_gbm = GradientBoostingClassifier()

#modélisation
m_gbm.fit(autos.iloc[:,1:],autos.iloc[:,0])

#importance des variables
print(pandas.DataFrame({'variable':autos.columns[1:],'coef':m_gbm.feature_importances_}))

#position des variables selon l'importance
import numpy
pos = numpy.argsort(m_gbm.feature_importances_)

#affichage graphique
pandas.Series(m_gbm.feature_importances_[pos],index=autos.columns[1:][pos]).plot(kind='barh')

#classe de calcul pour partial dependence plot
from sklearn.ensemble.partial_dependence import plot_partial_dependence

#graphique pour wheel_base et normalized_losses
plot_partial_dependence(m_gbm,autos.iloc[:,1:],feature_names=autos.columns[1:],features=[0,2],grid_resolution=15)

#graphique pour l'effet conjoint de wheel_base et normalized_losses
plot_partial_dependence(m_gbm,autos.iloc[:,1:],feature_names=autos.columns[1:],features=[(0,2)],grid_resolution=15)
